'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Router = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

require('./animation.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var vp = void 0; // view params，视图通过路由传递的参数
function getPath(url) {
    return (url || location.hash).replace(/^#\//, '');
}
function resolvePath() {
    var path = arguments.length <= 0 || arguments[0] === undefined ? getPath() : arguments[0];

    var actions = path.split('/');
    var viewName = actions.shift();

    return { viewName: viewName, actions: actions };
}

var Router = exports.Router = _react2.default.createClass({
    displayName: 'Router',

    getInitialState: function getInitialState() {
        return {
            visuals: []
        };
    },
    getDefaultProps: function getDefaultProps() {
        return {
            transitionName: 'zoom-fade',
            baseView: 'base'
        };
    },

    componentDidMount: function componentDidMount() {
        var that = this;
        var baseView = that.props.baseView;

        function onpopstate() {
            // 通用路由规则
            // /{viewName}/{params}
            var path = getPath() || baseView;

            var _resolvePath = resolvePath(path);

            var viewName = _resolvePath.viewName;
            var actions = _resolvePath.actions;

            var params = vp;
            vp = null; // reset

            var visuals = that.state.visuals.slice();
            var targetViewState = history.state;
            var currentView = visuals.slice(-1)[0];
            var lastView = visuals.length > 1 && visuals.slice(-2)[0];

            if (lastView && targetViewState && lastView.key == targetViewState.key) {
                // close current view
                visuals.pop();
            } else {
                // targetView is currentView(eg: open none view then back)
                // skip
                if (currentView && targetViewState && currentView.key == targetViewState.key) return;

                // next router is last, fix back
                var lastViewPath = lastView && lastView.props['data-path'];
                if (path == lastViewPath) return history.go(-2);

                // set view state for close
                var key = 'v' + Date.now();
                history.replaceState({ key: key }, '', location.hash);

                // open new view
                var View = that.props.views[viewName];
                if (View) {
                    var visual = _react2.default.createElement(
                        'div',
                        { className: 'view', key: key, 'data-path': path },
                        _react2.default.createElement(View, { actions: actions, params: params })
                    );

                    if (viewName == baseView) visuals = [visual]; // reset for baseView
                    else visuals.push(visual); // open normal view
                }
            }

            that.setState({ visuals: visuals });
        }
        window.addEventListener('popstate', onpopstate);
        onpopstate(); // start router
    },
    render: function render() {
        var transitionName = this.props.transitionName;
        var visuals = this.state.visuals;


        return _react2.default.createElement(
            _reactAddonsCssTransitionGroup2.default,
            {
                transitionName: transitionName,
                transitionEnterTimeout: 400,
                transitionLeaveTimeout: 400,
                transitionEnter: visuals.length > 1,
                component: 'div', id: 'views' },
            visuals
        );
    }
});

// router api
exports.default = {
    goto: function goto(actions, params) {
        vp = params; // set view params first
        location.hash = '#' + actions; // then router to view
    },
    getPath: getPath, resolvePath: resolvePath,
    back: function back() {
        history.back();
    },
    reload: function reload() {
        /* global plus */
        if (window.plus) plus.runtime.restart();else location.href = location.href.replace(location.hash, '');
    }
};